%grammar
	Document
		= OptMiscElemList Element OptMiscElemList
		;
	OptMiscElemList
		= OptMiscElemList MiscElem
		|
		;
	MiscElem
		= { Comment } COMMENT
		| { Instr   } ProcInstr
		;
	ProcInstr
		= PI_OPEN NAME OptAttrList PI_CLOSE
		;
	OptAttrList
		= OptAttrList Attribute
		|
		;
	Attribute
		= { NameOnly     }  NAME
		| { NameAndValue }	NAME "=" VALUE
		;
	Element
		= { Standalone  } TAG_OPEN NAME OptAttrList TAG_END
		| { WithContent } TAG_OPEN NAME OptAttrList TAG_CLOSE Content END_TAG NAME TAG_CLOSE
		;
	Content
		= Content ContentItem
		|
		;
	ContentItem
		= { Text } TEXT
		| { Misc } MiscElem
		| { Elem } Element
		;
		
%macros
    any = [^] 
        ;
    dot = any \ [\n\r]
        ;
	namestart
		= [A-Za-z\x80-\xff_]
		;
	namechar
		= [A-Za-z\x80-\xff_0-9\.]
		;
	esc = "&#" [0-9]+ ";" | "&#x" [0-9a-fA-F]+ ";"
		;
		
%tokens
	NAME
		= namestart namechar*
		;
	VALUE
		= ["] ( [^"&] | esc )* ["] | ['] ( [^'&] | esc )* [']
		;
	COMMENT
		= "<!--" ( [^-] | "-" [^-] )* "-->"
		;
	PI_OPEN
		= "<?"
			>> MAIN
		;
	PI_CLOSE
		= "?>"
			>> START_TEXT
		;
	TAG_OPEN
		= "<"
			>> MAIN
		;
	TAG_CLOSE
		= ">"
			>> START_TEXT
		;
	TAG_END 
		= "/>"
			>> START_TEXT
		;
	END_TAG
		= "</"
			>> MAIN
		; 
    WS  = [ \t]+
            { "Skip" }
        ;
	TEXT @ START_TEXT
		= ( [^<&\n\r] | esc )+
		;
    NL  = "\r" | "\n" | "\r\n"
            { "NewLine", "Skip" }
        ;
		