package xml;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.RandomAccessFile;
import java.io.Reader;

public class Run {

    public static void main(String[] args) throws IOException {
        int numLoops = Integer.parseInt(args[1]);
        RandomAccessFile f = new RandomAccessFile(args[0], "r");
        int l = (int) f.length();
        byte[] txt = new byte[l];
        f.readFully(txt);
        f.close();
        
        for (int i = 0; i < 2000; i++) {
            run(txt);
        }
        
        long t0 = System.currentTimeMillis();
        for (int i = 0; i < numLoops; i++) {
            run(txt);
        }
        long dt = System.currentTimeMillis() - t0;
        System.out.println("dt = " + dt + " ms");
    }

    private static void run(byte[] txt) throws IOException {
        Reader reader = new InputStreamReader(new ByteArrayInputStream(txt));
        Object goal = new Parser().parse(new Scanner(reader));
        if (goal != null) {
            throw new IllegalStateException("Oops!");
        }
    }
    
}
