package xml;
import xml.AST.*;
public abstract class BaseParser extends beaver.Parser {
	protected Document createDocument(OptMiscElemList optMiscElemList, Element element, OptMiscElemList optMiscElemList2) {
		return new Document(optMiscElemList, element, optMiscElemList2);
	}
	protected OptMiscElemList createOptMiscElemList() {
		return new OptMiscElemList();
	}
	protected void extendOptMiscElemList(OptMiscElemList list, MiscElem item) {
		list.add(item);
	}
	protected MiscElem createCommentMiscElem(Term comment) {
		return new MiscElem.Comment(comment);
	}
	protected MiscElem createInstrMiscElem(ProcInstr procInstr) {
		return new MiscElem.Instr(procInstr);
	}
	protected ProcInstr createProcInstr(Term name, OptAttrList optAttrList) {
		return new ProcInstr(name, optAttrList);
	}
	protected OptAttrList createOptAttrList() {
		return new OptAttrList();
	}
	protected void extendOptAttrList(OptAttrList list, Attribute item) {
		list.add(item);
	}
	protected Attribute createNameOnlyAttribute(Term name) {
		return new Attribute.NameOnly(name);
	}
	protected Attribute createNameAndValueAttribute(Term name, Term value) {
		return new Attribute.NameAndValue(name, value);
	}
	protected Element createStandaloneElement(Term name, OptAttrList optAttrList) {
		return new Element.Standalone(name, optAttrList);
	}
	protected Element createWithContentElement(Term name, OptAttrList optAttrList, Content content, Term name2) {
		return new Element.WithContent(name, optAttrList, content, name2);
	}
	protected Content createContent() {
		return new Content();
	}
	protected void extendContent(Content list, ContentItem item) {
		list.add(item);
	}
	protected ContentItem createTextContentItem(Term text) {
		return new ContentItem.Text(text);
	}
	protected ContentItem createMiscContentItem(MiscElem miscElem) {
		return new ContentItem.Misc(miscElem);
	}
	protected ContentItem createElemContentItem(Element element) {
		return new ContentItem.Elem(element);
	}
}
